
#line 1 "ansi_parser.rl"
#include <fmt/core.h>
#include <string_view>
#include "dbc.hpp"
#include <SFML/Graphics.hpp>
#include "ansi_parser.hpp"
#include <iostream>

using namespace fmt;


#line 115 "ansi_parser.rl"



#line 13 "ansi_parser.cpp"
static const char _ansi_parser_actions[] = {
	0, 1, 0, 1, 3, 1, 4, 1, 
	5, 1, 6, 1, 7, 1, 8, 1, 
	9, 1, 10, 1, 11, 1, 15, 1, 
	16, 2, 1, 12, 2, 1, 13, 2, 
	16, 5, 3, 1, 14, 2
};

static const char _ansi_parser_key_offsets[] = {
	0, 0, 1, 2, 10, 11, 13, 16, 
	19, 20, 24, 25, 26, 27, 28, 30, 
	33, 35, 38, 40, 43, 44, 47, 48, 
	49, 50, 51, 52
};

static const int _ansi_parser_trans_keys[] = {
	27, 91, 49, 50, 51, 52, 55, 57, 
	48, 54, 109, 48, 109, 34, 48, 55, 
	50, 55, 109, 109, 49, 56, 57, 109, 
	109, 59, 50, 59, 48, 57, 59, 48, 
	57, 48, 57, 59, 48, 57, 48, 57, 
	109, 48, 57, 109, 56, 57, 109, 59, 
	50, 109, 109, 27, 27, 0
};

static const char _ansi_parser_single_lengths[] = {
	0, 1, 1, 6, 1, 2, 3, 3, 
	1, 4, 1, 1, 1, 1, 0, 1, 
	0, 1, 0, 1, 1, 3, 1, 1, 
	1, 1, 1, 1
};

static const char _ansi_parser_range_lengths[] = {
	0, 0, 0, 1, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 1, 1, 
	1, 1, 1, 1, 0, 0, 0, 0, 
	0, 0, 0, 0
};

static const char _ansi_parser_index_offsets[] = {
	0, 0, 2, 4, 12, 14, 17, 21, 
	25, 27, 32, 34, 36, 38, 40, 42, 
	45, 47, 50, 52, 55, 57, 61, 63, 
	65, 67, 69, 71
};

static const char _ansi_parser_trans_targs[] = {
	2, 1, 3, 0, 5, 7, 9, 21, 
	25, 6, 4, 0, 27, 0, 6, 27, 
	0, 4, 4, 4, 0, 4, 8, 27, 
	0, 27, 0, 10, 11, 20, 27, 0, 
	27, 0, 12, 0, 13, 0, 14, 0, 
	15, 0, 16, 15, 0, 17, 0, 18, 
	17, 0, 19, 0, 27, 19, 0, 27, 
	0, 22, 24, 27, 0, 23, 0, 13, 
	0, 27, 0, 27, 0, 2, 1, 2, 
	1, 0
};

static const char _ansi_parser_trans_actions[] = {
	0, 7, 0, 0, 21, 21, 21, 21, 
	21, 21, 21, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 17, 
	0, 15, 0, 0, 0, 0, 0, 0, 
	19, 0, 0, 0, 3, 0, 0, 0, 
	1, 0, 25, 0, 0, 1, 0, 28, 
	0, 0, 1, 0, 34, 0, 0, 9, 
	0, 0, 0, 0, 0, 0, 0, 5, 
	0, 11, 0, 13, 0, 0, 7, 23, 
	31, 0
};

static const char _ansi_parser_eof_actions[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 23
};

static const int ansi_parser_start = 26;
static const int ansi_parser_first_final = 26;
static const int ansi_parser_error = 0;

static const int ansi_parser_en_main = 26;


#line 118 "ansi_parser.rl"

#include <ftxui/screen/terminal.hpp>

ANSIParser::ANSIParser(sf::Color default_fg, sf::Color default_bg) :
  $default_fg(default_fg),
  $default_bg(default_bg)
{
  // the parser only handles full color so force it
  if(ftxui::Terminal::ColorSupport() != ftxui::Terminal::Color::TrueColor) {
    ftxui::Terminal::SetColorSupport(ftxui::Terminal::Color::TrueColor);
  }
}

bool ANSIParser::parse(std::wstring_view codes, ColorCB color_cb, WriteCB write_cb) {
  const wchar_t *start = NULL;
  int cs = 0;
  unsigned int value = 0;
  const wchar_t *p = codes.data();
  const wchar_t *pe = p + codes.size();
  const wchar_t *eof = pe;
  sf::Color bgcolor($default_bg);
  sf::Color color($default_fg);
  sf::Color &target = color;

  
#line 122 "ansi_parser.cpp"
	{
	cs = ansi_parser_start;
	}

#line 143 "ansi_parser.rl"
  
#line 125 "ansi_parser.cpp"
	{
	int _klen;
	unsigned int _trans;
	const char *_acts;
	unsigned int _nacts;
	const int *_keys;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_keys = _ansi_parser_trans_keys + _ansi_parser_key_offsets[cs];
	_trans = _ansi_parser_index_offsets[cs];

	_klen = _ansi_parser_single_lengths[cs];
	if ( _klen > 0 ) {
		const int *_lower = _keys;
		const int *_mid;
		const int *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( (*p) < *_mid )
				_upper = _mid - 1;
			else if ( (*p) > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (unsigned int)(_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _ansi_parser_range_lengths[cs];
	if ( _klen > 0 ) {
		const int *_lower = _keys;
		const int *_mid;
		const int *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( (*p) < _mid[0] )
				_upper = _mid - 2;
			else if ( (*p) > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += (unsigned int)((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	cs = _ansi_parser_trans_targs[_trans];

	if ( _ansi_parser_trans_actions[_trans] == 0 )
		goto _again;

	_acts = _ansi_parser_actions + _ansi_parser_trans_actions[_trans];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 )
	{
		switch ( *_acts++ )
		{
	case 0:
#line 14 "ansi_parser.rl"
	{
    start = p;
  }
	break;
	case 1:
#line 18 "ansi_parser.rl"
	{
    value = 0;
    size_t len = p - start;
    dbc::check(start[0] != '-', "negative numbers not supported");

    switch(len) {
      case 10:    value += (start[len-10] - '0') * 1000000000;
      case  9:    value += (start[len- 9] - '0') * 100000000;
      case  8:    value += (start[len- 8] - '0') * 10000000;
      case  7:    value += (start[len- 7] - '0') * 1000000;
      case  6:    value += (start[len- 6] - '0') * 100000;
      case  5:    value += (start[len- 5] - '0') * 10000;
      case  4:    value += (start[len- 4] - '0') * 1000;
      case  3:    value += (start[len- 3] - '0') * 100;
      case  2:    value += (start[len- 2] - '0') * 10;
      case  1:    value += (start[len- 1] - '0');
        break;
      default:
        dbc::sentinel("can't process > 10 digits");
    }
  }
	break;
	case 2:
#line 40 "ansi_parser.rl"
	{
    color_cb(color, bgcolor);
  }
	break;
	case 3:
#line 43 "ansi_parser.rl"
	{
    target = color;
  }
	break;
	case 4:
#line 46 "ansi_parser.rl"
	{
    target = bgcolor;
  }
	break;
	case 5:
#line 50 "ansi_parser.rl"
	{
    write_cb((*p));
  }
	break;
	case 6:
#line 54 "ansi_parser.rl"
	{ color = $default_fg; }
	break;
	case 7:
#line 55 "ansi_parser.rl"
	{ bgcolor = $default_bg; }
	break;
	case 8:
#line 56 "ansi_parser.rl"
	{
    color = $default_bg;
    bgcolor = $default_fg;
    color_cb(color, bgcolor);
  }
	break;
	case 9:
#line 61 "ansi_parser.rl"
	{
    color = $default_fg;
    bgcolor = $default_bg;
    color_cb(color, bgcolor);
  }
	break;
	case 10:
#line 66 "ansi_parser.rl"
	{
    color = sf::Color(100,100,100);
    color_cb(color, bgcolor);
  }
	break;
	case 11:
#line 70 "ansi_parser.rl"
	{
    color = sf::Color::Red;
    color_cb(color, bgcolor);
  }
	break;
	case 12:
#line 75 "ansi_parser.rl"
	{ target.r = value; }
	break;
	case 13:
#line 76 "ansi_parser.rl"
	{ target.g = value; }
	break;
	case 14:
#line 77 "ansi_parser.rl"
	{ target.b = value; }
	break;
	case 15:
#line 78 "ansi_parser.rl"
	{ value = 0; }
	break;
	case 16:
#line 79 "ansi_parser.rl"
	{}
	break;
#line 292 "ansi_parser.cpp"
		}
	}

_again:
	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	if ( p == eof )
	{
	const char *__acts = _ansi_parser_actions + _ansi_parser_eof_actions[cs];
	unsigned int __nacts = (unsigned int) *__acts++;
	while ( __nacts-- > 0 ) {
		switch ( *__acts++ ) {
	case 16:
#line 79 "ansi_parser.rl"
	{}
	break;
#line 310 "ansi_parser.cpp"
		}
	}
	}

	_out: {}
	}

#line 144 "ansi_parser.rl"

  bool good = pe - p == 0;

  if(!good) {
    println("FAIL AT {}", pe - p);
    p -= 10;
    // dear cthuhlu, save me from the pain that is wstring
    for(int i = 0; i < 100; i++) {
      try {
        print("{}", p[i] == 0x1B ? '^' : char(p[i]));
      } catch(...) {
        print("?=", int(p[i]));
      }
    }
  }

  return good;
}
